// PropsView.cpp : implementation of the CPropsView class
//

#include "stdafx.h"
#include "Props.h"
#include "propsheet.h"

#include "PropsDoc.h"
#include "PropsView.h"
#include ".\propsview.h"
#include "Page1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPropsView

IMPLEMENT_DYNCREATE(CPropsView, CView)

BEGIN_MESSAGE_MAP(CPropsView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
    ON_COMMAND(ID_FILE_PROPERTYSHEET, OnFilePropertysheet)
    ON_MESSAGE(WM_PROPCHANGE, OnPropChange)
END_MESSAGE_MAP()

// CPropsView construction/destruction

CPropsView::CPropsView()
{
    m_edit = "Default";
    m_check = FALSE;
	m_pPropSheet = new CPropSheet("Property Sheet", this, 0);
	m_pPropSheet->SetView(this);
}

CPropsView::~CPropsView()
{
	delete m_pPropSheet;
}

BOOL CPropsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CPropsView drawing

void CPropsView::OnDraw(CDC* pDC)
{
	CPropsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


    pDC->TextOut(20, 20, m_edit);
    if (m_check)
        pDC->TextOut(20, 50, "TRUE");
    else
        pDC->TextOut(20, 50, "FALSE");
}


// CPropsView printing

BOOL CPropsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPropsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPropsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CPropsView diagnostics

#ifdef _DEBUG
void CPropsView::AssertValid() const
{
	CView::AssertValid();
}

void CPropsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPropsDoc* CPropsView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPropsDoc)));
	return (CPropsDoc*)m_pDocument;
}
#endif //_DEBUG


// CPropsView message handlers

void CPropsView::OnFilePropertysheet()
{
    m_pPropSheet->m_page1.m_edit = m_edit;
    m_pPropSheet->m_page2.m_checkbox = m_check;
    int result = m_pPropSheet->DoModal();
    if (result == IDOK)
    {
        m_edit = m_pPropSheet->m_page1.m_edit;
        m_check = m_pPropSheet->m_page2.m_checkbox;
        Invalidate();
    }
}

LRESULT CPropsView::OnPropChange(WPARAM wParam, LPARAM lParam)
{
	TRACE("%d %d\n", wParam, lParam);
	m_edit = m_pPropSheet->m_page1.m_edit;
    m_check = m_pPropSheet->m_page2.m_checkbox;
    Invalidate();
	return 0L;
}
